/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Edelsteine.
    
    Edelsteine is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    Edelsteine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	    
    You should have received a copy of the GNU General Public License
    along with Edelsteine; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************************/

// Game-Headerdatei Edelsteine

#ifndef CHIPS_H
#define CHIPS_H

#include "config.h"
#include <qcanvas.h>
#include <qtimer.h>

class chips:public QCanvas
{
  Q_OBJECT
  
  public:
  chips(QWidget* parent=0);
  QCanvasPixmapArray* my_pixarray;
  QCanvasPixmapArray* my_goverarray;
  QCanvasPixmapArray* my_pausearray;
  QCanvasSprite* p_sprite[SMAX]; // anders ging es leider nicht
  QCanvasSprite* p_pause;
  QCanvasSprite* p_gover;
  
  bool aktiv,wertung,pausiert;
  int punkte,level,zeit,leben,gewaehlt;
  int fstart,fend,fakt,grenze,tic;
  int f[SMAX],h_liste[SMAX];
  QString levelname; 	      
  QTimer* my_timer;
  QTimer* my_stopper;
  
  private:
  void reset_timer();
  void game_over();
  void weiter();
  void zeige_feld(int);
  int  gain(int);
  void updat_level();
  void get_kette(int);
  void kette_auswerten();

  bool check_zug(int,int);
  int  zug_moeglich();

  public slots:
  void neues_spiel();
  void pause();
  void klick(int);
  void ticken();
  void droppen();
  void fuellen();
  void bereinigen();

  signals:
  void punkte_changed(int);
  void ticker_changed(int);
  void zeit_changed(int);
  void level_changed(QString);
  void gameover(int); // Punkte weiterreichen und bei Bedarf HSC-Eintrag oder Gameover-Bild (Sprite?)
};

#endif
