/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Edelsteine.
    
    Edelsteine is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    Edelsteine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	    
    You should have received a copy of the GNU General Public License
    along with Edelsteine; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************************/

// Hauptprogramm Edelsteine
// zu Fuss an die QT-Libs: Edelsteine
// ----------------------------------------------------------------------

#include "config.h"     // ein paar Konstanten
#include "window.h"     // Hauptfenster
#include "textviewer.h" // Infofenster
#include "hiscore.h"    // Bestenlistenmodule
#include "chips.h"      // Gameparameter und -routinen 

#include <qapplication.h>      // Fensterhandling-Event-Routinen
#include <qlayout.h>
#include <qmenubar.h>          // Menuleiste
#include <qmenudata.h>         // Menu-Items
#include <qaccel.h>


// -------------------------------------------------------------------------------------------------------

int main(int argc, char **argv)
{ 
  QApplication my_app(argc,argv);               // die Fenster/Appli-Steuerung small,rezize,quit
  window*      my_window    =new window();      // eine Instanz des zu zeigenden Spiel-Hauptfensters
  hiscore*     my_hiscore   =new hiscore();     // Bestenlisten-Hauptfenster
  textviewer*  my_textviewer=new textviewer();  // Fenster fuer Hilfstexte
  chips*       my_chips     =new chips(my_window);
  viewport*    my_view=my_window->my_view;

//  QMouseEvent* my_mouseclick=new my_view->contentsMousePressEvent();

    
// --- allgemeines Spielemenu: -----------------------------------------------------------------------------------------      
// erzeugen:
  QMenuBar*   my_menubar=new QMenuBar(my_window);  // Menubar mit Window berbinden    
  QPopupMenu* my_menu1 = new QPopupMenu;           // hier geht alles automatisch  
  QPopupMenu* my_menu2 = new QPopupMenu;           // second verse, same as the first

// bevoelkern: 
  my_menubar->insertItem(MENU10,my_menu1);  // Menuetitel
  my_menu1->insertItem(MENU11,my_chips,SLOT(neues_spiel()),QKeySequence(KUERZEL11),11);         
  my_menu1->insertItem(MENU12,my_chips,SLOT(pause()),QKeySequence(KUERZEL12),12);     // Dialog1:4 Items   
  my_menu1->insertSeparator();
  my_menu1->insertItem(MENU14,my_hiscore,SLOT(show_hsc()),QKeySequence(KUERZEL14),14); // HSC einswappen
  my_menu1->insertItem(LOEHSC,my_hiscore,SLOT(reset_hsc())); 
  my_menu1->insertSeparator();
  my_menu1->insertItem(MENU15,&my_app,SLOT(quit()),QKeySequence(KUERZEL15),15);  // slot quit wird eingeschleppt 
  my_menu1->insertSeparator();

// Info-Menuitem:
  my_menubar->insertSeparator();
  my_menubar->insertItem(MENU20,my_menu2);
  my_menu2->insertItem(MENU21,my_textviewer,SLOT(show_info(int)),QKeySequence(KUERZEL21),21);
  my_menu2->insertItem(MENU22,my_textviewer,SLOT(show_info(int)),QKeySequence(KUERZEL22),22); 
  my_menu2->insertItem(MENU23,my_textviewer,SLOT(show_info(int)),0,23); 

  my_menubar->setItemParameter(23,2);
  my_menubar->setItemParameter(21,1);
  my_menubar->setItemParameter(22,0);
 
// Testen:
 
// --------------------------------------------------------------------------------------------------------------------
// leider gings nicht anders, der QCanvas musste ins main:
  int breite=DX*XMAX+2*OFX,hoehe=DY*YMAX+2*OFY;
  QCanvas* my_canvas=new QCanvas(breite+20,hoehe+20);
  my_view->setCanvas(my_canvas);    
  my_view->setHScrollBarMode(QScrollView::AlwaysOff);
  my_view->setVScrollBarMode(QScrollView::AlwaysOff);
  
  my_canvas->setBackgroundColor(BACKGR1);
  my_canvas->setAdvancePeriod(50);       // 50ms-Ticker

  my_chips->my_pixarray=new QCanvasPixmapArray(SPRITEFILES,NUMSPRITES);
  my_chips->my_goverarray=new QCanvasPixmapArray(GAMEOVERFILE);
  my_chips->my_pausearray=new QCanvasPixmapArray(PAUSEFILE);
  my_chips->p_gover=new QCanvasSprite(my_chips->my_goverarray,my_canvas);
  my_chips->p_pause=new QCanvasSprite(my_chips->my_pausearray,my_canvas);
  my_chips->p_pause->setZ(SMAX+1); my_chips->p_pause->move(0,OFY+2*DY);
  my_chips->p_gover->setZ(SMAX+2); my_chips->p_gover->move(0,OFY+2*DY);
  
  int i,j,k=0,x,y;
  for (j=0; j<YMAX; j++) for (i=0; i<XMAX; i++)
  { x=i*DX+OFX; y=j*DY+OFY; 
    my_chips->p_sprite[k]=new QCanvasSprite(my_chips->my_pixarray,my_canvas);
    my_chips->p_sprite[k]->move(x,y,(k%CMAX+1));
    my_chips->p_sprite[k]->setVisible(true);
    k++;
  }
 
  my_chips->neues_spiel();
  my_view->polish();
  my_view->show();	    
  
// ---------------------------------------------------------------------------------------------------------------------
  my_app.setMainWidget(my_window);        // my_window als Hauptfenster  
  my_app.connect(my_view,SIGNAL(geklickt(int)),my_chips,SLOT(klick(int)));
  my_app.connect(my_chips,SIGNAL(gameover(int)),my_hiscore,SLOT(save_hsc(int)));

  QPixmap my_pixmap=QPixmap(PROGICON); 
  my_window->setIcon(my_pixmap);
  my_window->show();                      // anzeigen
  return my_app.exec();                   // Exec-Schleife der my_app
}
