/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Edelsteine.
    
    Edelsteine is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    Edelsteine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	    
    You should have received a copy of the GNU General Public License
    along with Edelsteine; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************************/

// Textviewer fr Hilfe und Info  Edelsteine

#include "textviewer.h"
#include <qtextstream.h>

void textviewer::hide_info() { hide(); }
// Textanzeige aus beliebiger RichText-Datei:
// ----------------------------------------------

void textviewer::show_info(const int flag)
{ 
// Datei einlesen in buffall, Abschnitt ist ok:
  QString buff,infile;
  if (flag==0)      { infile=INFOFILE; resize(INFOBREITE,320); setCaption(INFOTITEL); }
  else if (flag==1) { infile=HELPFILE; resize(HELPBREITE,320); setCaption(HELPTITEL); }
  else if (flag==2) { infile=GPLFILE;  resize(HELPBREITE,320); setCaption(LIZENZTITEL); }
  else { infile="unbekannt"; resize(240,96); }
  
  QString buffout="Problemo:Datei "+infile+" nicht gefunden!";
  QFile file(infile); // Read the text from a file
  if ( file.open( IO_ReadOnly ) )
  {
    QTextStream stream(&file);
    my_text->setText( stream.read() );
  }
  polish();
  show();
  raise();
}


textviewer::textviewer(QWidget* parent,char* name): QVBox(parent,name)
{ 
  // Textfeld:
  my_text=new QTextEdit(this); // Deklaration im Header hinreichend, sonst wird Headervariable geplttet
  my_text->setReadOnly(true);
  my_text->setTextFormat(RichText);
  QBrush* my_brush=new QBrush(COLOR1,QPixmap(PAPERBILD));
  my_text->setPaper(*my_brush);
     
  // mittiger Button:
  QHBox* p_mittig=new QHBox(this);
  QLabel* p_leer1=new QLabel(p_mittig);
  QPushButton* p_wech=new QPushButton(SCHLIESSEN,p_mittig);
  QLabel* p_leer2=new QLabel(p_mittig);
  p_mittig->setStretchFactor(p_leer1,10); 
  p_mittig->setStretchFactor(p_leer2,10); 
  p_mittig->setStretchFactor(p_wech,10);
  connect(p_wech,SIGNAL(clicked()),this,SLOT(hide_info()));
            
}
