/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Edelsteine.
    
    Edelsteine is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    Edelsteine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	    
    You should have received a copy of the GNU General Public License
    along with Edelsteine; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************************/

// Hauptfenster Edelsteine

#include "window.h"

viewport::viewport(QWidget* parent, char* name):QCanvasView(parent,name)
{ 
  int breite=DX*XMAX+2*OFX+4,hoehe=DY*YMAX+2*OFY+4;
  setMinimumSize(breite,hoehe);
  setMaximumSize(breite+16,hoehe+16);
}
	  
void viewport::contentsMousePressEvent( QMouseEvent *e )
{
  int fnum=-1,xx,yy;
  maus_x=e->x(); maus_y=e->y();
// so lange die keinen Namen bekommen koennen, ist diese Funktion witzlos:  
//  QCanvasItemList liste=canvas()->collisions(e->pos());

  xx=(maus_x-OFX)/DX;
  yy=(maus_y-OFY)/DY;
  if ((xx>=0) && (yy>=0) && (xx<XMAX) && (yy<YMAX)) fnum=xx+yy*XMAX;
  emit(geklickt(fnum));
}


window::window(QWidget *parent,char* name): QHBox(parent,name)
{ 
  this->setMargin(16);
  this->setSpacing(8);
  this->setPaletteBackgroundColor(BACKGR0);
  this->setCaption(TITEL);  
  this->setMaximumSize(WIN_BMAX,WIN_HMAX);
  this->setMinimumSize(WIN_BMIN,WIN_HMIN);

// Feld links: Spielwiese und Padding nach unten
  QVBox* p_spalte0=new QVBox(this);
  my_view=new viewport(this,"playfield"); // QCanvasView-Variante
  my_view->show(); 
  QLabel* p_zero0=new QLabel(p_spalte0);
  p_spalte0->setStretchFactor(p_zero0,10);
  p_spalte0->setStretchFactor(my_view,0);
  
  // naechste Spalte:
  QVBox* p_spalte1=new QVBox(this);
  p_spalte1->setMargin(8);             // Container fuer Block Ueberschrift/Anzeigen und Canvas 
  p_spalte1->setSpacing(8); 
  // Ueberschrift als Pixmap
  QLabel* p_ue =new QLabel(p_spalte1);
  p_ue->setPixmap(QPixmap(TITELBILD)); 

  // Anzeigetafel:
  QGrid* p_anzeigen=new QGrid(2,p_spalte1,"anzeigen");  // Anzeigetafel
  p_anzeigen->setMinimumSize(192,96);
  p_anzeigen->setFrameShadow(Sunken);
  p_anzeigen->setFrameShape(Box);
  p_anzeigen->setMargin(16);
  p_anzeigen->setPaletteBackgroundPixmap(QPixmap(BACKBILD2));
  p_anzeigen->setPaletteForegroundColor(COLOR2);
  QLabel* p_llevel =new QLabel(p_anzeigen); p_level  =new QLabel(p_anzeigen);    
  QLabel* p_lleben =new QLabel(p_anzeigen); p_leben  =new QLabel(p_anzeigen);  
  QLabel* p_lzeit  =new QLabel(p_anzeigen); p_zeit   =new QLabel(p_anzeigen);  
  QLabel* p_lpunkte=new QLabel(p_anzeigen); p_punkte =new QLabel(p_anzeigen); 

  
  // Ticker:
  QHBox* p_ticker=new QHBox(p_spalte1,"timeticker"); 
  for (int i=0; i<ZEIT0; i++) p_tick[i]=new QLabel(p_ticker); 
 
  QLabel* p_zero1=new QLabel(p_spalte1);
  p_spalte1->setStretchFactor(p_anzeigen,0);
  p_spalte1->setStretchFactor(p_zero1,10);
// alles weitere (HSC) haengt sich rechts dran

// Daten einfuellen:  
  p_llevel ->setText(ANZEIGE0); if (ANZEIGE0!="") p_level->setText("Eazy does it!");
  p_lleben ->setText(ANZEIGE3); if (ANZEIGE3!="") p_leben->setNum(5);
  p_lzeit  ->setText(ANZEIGE2); if (ANZEIGE2!="") p_zeit->setNum(999);
  p_lpunkte->setText(ANZEIGE1); if (ANZEIGE1!="") p_punkte->setNum(0);

}

void window::set_punkte(int p)    { p_punkte->setNum(p); }
void window::set_zeit(int p)      { p_zeit->setNum(p); }
void window::set_leben(int p)     { p_leben->setNum(p); }
void window::set_level(QString p) { p_level->setText(p); }

void window::set_ticker(int p)
{
  for (int i=0; i<ZEIT0; i++) 
   if (i<p) p_tick[i]->setPixmap(QPixmap(TIMEDOT_ON)); else  p_tick[i]->setPixmap(QPixmap(TIMEDOT_OFF));
  // if (i<p) p_tick[i]->setText("o"); else p_tick[i]->setText(" ");
}
