/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Edelsteine.
    
    Edelsteine is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
	    
    Edelsteine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	    
    You should have received a copy of the GNU General Public License
    along with Edelsteine; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************************/

// Headerfile fuer Objekt window: window.h
// erstellt ein zweigeteiltes Fenster, links Grafikausgabe, rechts Eingabeparameter und Anzeigen
// Klamotten wie Help, Neu  Load und Save werden von QApplication in main.cpp erledigt
// ----------------------------------------------------------------------------------------------

#ifndef WINDOW_H
#define WINDOW_H

#include "config.h"

#include <qvbox.h>        // Anzeige-Unterteilung
#include <qhbox.h>        // Basis dieses Windows
#include <qgrid.h>        // Unterteilungsgitter
#include <qlabel.h>       // Anzeigen 
#include <qlineedit.h>    // Eingaben
#include <qcanvas.h>      // Spielwiese
#include <qtextedit.h>    // Infofenster
#include <qapplication.h>

class viewport:public QCanvasView
{
  Q_OBJECT
  
  public:
  viewport(QWidget* parent=0,char* name="viewport");
  int maus_x,maus_y,fnum;
		   
  protected:
  void contentsMousePressEvent  (QMouseEvent *e); //der wird gebraucht
  
  signals:
  void geklickt(int);  

};


class window : public QHBox
{
  Q_OBJECT

  public:
  window(QWidget* parent=0, char* name=0);

  QLabel*   p_level;    // setzen
  QLabel*   p_leben;
  QLabel*   p_zeit;
  QLabel*   p_punkte;
  QLabel*   p_tick[ZEIT0];
  
  viewport* my_view;
    
  public slots:
  void set_punkte(int);
  void set_zeit(int);
  void set_ticker(int);
  void set_leben(int);
  void set_level(QString);

};

#endif 
